OGRE: Ogre::StaticGeometry::Region::RegionShadowRenderable Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::StaticGeometry::Region::RegionShadowRenderable Class Reference

Nested class to allow region shadows. More...

`#include <OgreStaticGeometry.h>`

Inheritance diagram for Ogre::StaticGeometry::Region::RegionShadowRenderable:

[legend]
List of all members.

## Public Member Functions

| RegionShadowRenderable (Region *parent, HardwareIndexBufferSharedPtr *indexBuffer, const VertexData *vertexData, bool createSeparateLightCap, bool isLightCap=false)
| ~RegionShadowRenderable ()
void | getWorldTransforms (Matrix4 *xform) const
| Overridden from ShadowRenderable.
const Quaternion & | getWorldOrientation (void) const
| Overridden from ShadowRenderable.
const Vector3 & | getWorldPosition (void) const
| Overridden from ShadowRenderable.
HardwareVertexBufferSharedPtr | getPositionBuffer (void)
HardwareVertexBufferSharedPtr | getWBuffer (void)
void | setMaterial (const MaterialPtr &mat)
| Set the material to be used by the shadow, should be set by the caller before adding to a render queue.
const MaterialPtr & | getMaterial (void) const
| Overridden from Renderable.
void | getRenderOperation (RenderOperation &op)
| Overridden from Renderable.
RenderOperation * | getRenderOperationForUpdate (void)
| Get the internal render operation for set up.
Real | getSquaredViewDepth (const Camera *) const
| Overridden from Renderable.
const LightList & | getLights (void) const
| Overridden from Renderable.
bool | isLightCapSeparate (void) const
| Does this renderable require a separate light cap?
ShadowRenderable * | getLightCapRenderable (void)
| Get the light cap version of this renderable.
virtual bool | isVisible (void) const
| Should this ShadowRenderable be treated as visible?
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

## Protected Types

typedef std::map< size_t, Vector4 > | CustomParameterMap

## Protected Attributes

Region * | mParent
HardwareVertexBufferSharedPtr | mPositionBuffer
HardwareVertexBufferSharedPtr | mWBuffer
MaterialPtr | mMaterial
RenderOperation | mRenderOp
ShadowRenderable * | mLightCap
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView

## Static Protected Attributes

static const PlaneList | msDummyPlaneList

## Detailed Description

Nested class to allow region shadows.

Definition at line 355 of file OgreStaticGeometry.h.

## Member Typedef Documentation

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

## Constructor & Destructor Documentation

Ogre::StaticGeometry::Region::RegionShadowRenderable::RegionShadowRenderable | ( | Region * | parent,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | const VertexData * | vertexData,
|  | bool | createSeparateLightCap,
|  | bool | isLightCap = `false`
| ) |

Ogre::StaticGeometry::Region::RegionShadowRenderable::~RegionShadowRenderable | ( |  | ) |

## Member Function Documentation

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

Definition at line 252 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 187 of file OgreRenderable.h.

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 213 of file OgreRenderable.h.

References OGRE_EXCEPT.

ShadowRenderable* Ogre::ShadowRenderable::getLightCapRenderable | ( | void |  | ) | `[inherited]`

| Get the light cap version of this renderable. Definition at line 89 of file OgreShadowCaster.h.

const LightList& Ogre::ShadowRenderable::getLights | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

const MaterialPtr& Ogre::ShadowRenderable::getMaterial | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable. Definition at line 61 of file OgreShadowCaster.h.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 111 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

HardwareVertexBufferSharedPtr Ogre::StaticGeometry::Region::RegionShadowRenderable::getPositionBuffer | ( | void |  | ) |

| Definition at line 375 of file OgreStaticGeometry.h.

void Ogre::ShadowRenderable::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable. Definition at line 63 of file OgreShadowCaster.h.

RenderOperation* Ogre::ShadowRenderable::getRenderOperationForUpdate | ( | void |  | ) | `[inherited]`

| Get the internal render operation for set up. Definition at line 65 of file OgreShadowCaster.h.

Real Ogre::ShadowRenderable::getSquaredViewDepth | ( | const Camera * |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable. Definition at line 73 of file OgreShadowCaster.h.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 73 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 161 of file OgreRenderable.h.

HardwareVertexBufferSharedPtr Ogre::StaticGeometry::Region::RegionShadowRenderable::getWBuffer | ( | void |  | ) |

| Definition at line 376 of file OgreStaticGeometry.h.

const Quaternion& Ogre::StaticGeometry::Region::RegionShadowRenderable::getWorldOrientation | ( | void |  | ) | const`[virtual]`

| Overridden from ShadowRenderable. Implements Ogre::ShadowRenderable.

const Vector3& Ogre::StaticGeometry::Region::RegionShadowRenderable::getWorldPosition | ( | void |  | ) | const`[virtual]`

| Overridden from ShadowRenderable. Implements Ogre::ShadowRenderable.

void Ogre::StaticGeometry::Region::RegionShadowRenderable::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual]`

| Overridden from ShadowRenderable. Implements Ogre::ShadowRenderable.

bool Ogre::ShadowRenderable::isLightCapSeparate | ( | void |  | ) | const`[inherited]`

Does this renderable require a separate light cap?

Remarks:
  If possible, the light cap (when required) should be contained in the usual geometry of the shadow renderable. However, if for some reason the normal depth function (less than) could cause artefacts, then a separate light cap with a depth function of 'always fail' can be used instead. The primary example of this is when there are floating point inaccuracies caused by calculating the shadow geometry separately from the real geometry.

Definition at line 86 of file OgreShadowCaster.h.

virtual bool Ogre::ShadowRenderable::isVisible | ( | void |  | ) | const`[virtual, inherited]`

| Should this ShadowRenderable be treated as visible? Reimplemented in Ogre::Entity::EntityShadowRenderable. Definition at line 91 of file OgreShadowCaster.h.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 204 of file OgreRenderable.h.

void Ogre::ShadowRenderable::setMaterial | ( | const MaterialPtr & | mat | ) | `[inherited]`

| Set the material to be used by the shadow, should be set by the caller before adding to a render queue. Definition at line 59 of file OgreShadowCaster.h.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 269 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 147 of file OgreRenderable.h.

## Member Data Documentation

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

ShadowRenderable* Ogre::ShadowRenderable::mLightCap`[protected, inherited]`

| Definition at line 52 of file OgreShadowCaster.h.

MaterialPtr Ogre::ShadowRenderable::mMaterial`[protected, inherited]`

| Definition at line 50 of file OgreShadowCaster.h.

Region* Ogre::StaticGeometry::Region::RegionShadowRenderable::mParent`[protected]`

| Definition at line 358 of file OgreStaticGeometry.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

HardwareVertexBufferSharedPtr Ogre::StaticGeometry::Region::RegionShadowRenderable::mPositionBuffer`[protected]`

| Definition at line 360 of file OgreStaticGeometry.h.

RenderOperation Ogre::ShadowRenderable::mRenderOp`[protected, inherited]`

| Definition at line 51 of file OgreShadowCaster.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

HardwareVertexBufferSharedPtr Ogre::StaticGeometry::Region::RegionShadowRenderable::mWBuffer`[protected]`

| Definition at line 362 of file OgreStaticGeometry.h.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:12 2008